
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class GalleriesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const galleries = await db.galleries.create(
            {
                id: data.id || undefined,
        
        title_om: data.title_om
        ||
        null
            ,
            
        title_am: data.title_am
        ||
        null
            ,
            
        title_en: data.title_en
        ||
        null
            ,
            
        description_om: data.description_om
        ||
        null
            ,
            
        description_am: data.description_am
        ||
        null
            ,
            
        description_en: data.description_en
        ||
        null
            ,
            
        published: data.published
        ||
        false
        
            ,
            
        published_at: data.published_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.galleries.getTableName(),
                belongsToColumn: 'images',
                belongsToId: galleries.id,
            },
            data.images,
            options,
        );
        

        return galleries;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const galleriesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                title_om: item.title_om
            ||
            null
            ,
            
                title_am: item.title_am
            ||
            null
            ,
            
                title_en: item.title_en
            ||
            null
            ,
            
                description_om: item.description_om
            ||
            null
            ,
            
                description_am: item.description_am
            ||
            null
            ,
            
                description_en: item.description_en
            ||
            null
            ,
            
                published: item.published
            ||
            false
        
            ,
            
                published_at: item.published_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const galleries = await db.galleries.bulkCreate(galleriesData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < galleries.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.galleries.getTableName(),
                    belongsToColumn: 'images',
                    belongsToId: galleries[i].id,
                },
                data[i].images,
                options,
            );
        }
        

        return galleries;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const galleries = await db.galleries.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.title_om !== undefined) updatePayload.title_om = data.title_om;
        
        
        if (data.title_am !== undefined) updatePayload.title_am = data.title_am;
        
        
        if (data.title_en !== undefined) updatePayload.title_en = data.title_en;
        
        
        if (data.description_om !== undefined) updatePayload.description_om = data.description_om;
        
        
        if (data.description_am !== undefined) updatePayload.description_am = data.description_am;
        
        
        if (data.description_en !== undefined) updatePayload.description_en = data.description_en;
        
        
        if (data.published !== undefined) updatePayload.published = data.published;
        
        
        if (data.published_at !== undefined) updatePayload.published_at = data.published_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await galleries.update(updatePayload, {transaction});

        
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.galleries.getTableName(),
                belongsToColumn: 'images',
                belongsToId: galleries.id,
            },
            data.images,
            options,
        );
        

        return galleries;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const galleries = await db.galleries.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of galleries) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of galleries) {
                await record.destroy({transaction});
            }
        });


        return galleries;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const galleries = await db.galleries.findByPk(id, options);

        await galleries.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await galleries.destroy({
            transaction
        });

        return galleries;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const galleries = await db.galleries.findOne(
            { where },
            { transaction },
        );

        if (!galleries) {
            return galleries;
        }

        const output = galleries.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.images = await galleries.getImages({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [



      {
        model: db.file,
        as: 'images',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.title_om) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'galleries',
                        'title_om',
                        filter.title_om,
                    ),
                };
            }
            
            if (filter.title_am) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'galleries',
                        'title_am',
                        filter.title_am,
                    ),
                };
            }
            
            if (filter.title_en) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'galleries',
                        'title_en',
                        filter.title_en,
                    ),
                };
            }
            
            if (filter.description_om) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'galleries',
                        'description_om',
                        filter.description_om,
                    ),
                };
            }
            
            if (filter.description_am) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'galleries',
                        'description_am',
                        filter.description_am,
                    ),
                };
            }
            
            if (filter.description_en) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'galleries',
                        'description_en',
                        filter.description_en,
                    ),
                };
            }
            

            
            

            
            if (filter.published_atRange) {
                const [start, end] = filter.published_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    published_at: {
                    ...where.published_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    published_at: {
                    ...where.published_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.published) {
                where = {
                    ...where,
                published: filter.published,
            };
            }
            




            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.galleries.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'galleries',
                        'title_en',
                        query,
                    ),
                ],
            };
        }

        const records = await db.galleries.findAll({
            attributes: [ 'id', 'title_en' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['title_en', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.title_en,
        }));
    }

    
};

